package de.unileipzig.datenschutz.paper10.demo.data;

import jakarta.persistence.*;

import java.util.Objects;
import java.util.Set;

@Entity
public class FontsFingerprint {

    @Id
    @GeneratedValue(strategy= GenerationType.AUTO)
    private Long id;

    @ManyToMany(cascade = { CascadeType.ALL })
    @JoinTable(
            name="fonts_font",
            joinColumns = { @JoinColumn(name="fonts_id")},
            inverseJoinColumns = { @JoinColumn(name="font_id")}
    )
    private Set<FontsData> installedFonts;

    FontsFingerprint(){

    }
    public FontsFingerprint(Set<FontsData> installedFonts) {
        this.installedFonts = installedFonts;
    }

    public Set<FontsData> getInstalledFonts() {
        return installedFonts;
    }
}
