package de.unileipzig.datenschutz.paper10.demo.data;

import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;

import java.util.Objects;
import java.util.Set;

@Entity
public class HeaderFingerprint {

    @Id
    @GeneratedValue(strategy= GenerationType.AUTO)
    private Long id;
    private String osType;
    private String osVersion;
    private String osSubVersion;
    private String device;

    private String useragentFamily;
    private String useragentVerison;
    private String useragentSubVersion;

    private Set<String> accepts;
    private Set<String> encoding;
    private Set<String> languages;

    HeaderFingerprint(){

    }
    public HeaderFingerprint(String osType, String osVersion, String osSubVersion, String device, String useragentFamily, String useragentVerison, String useragentSubVersion, Set<String> accepts, Set<String> encoding, Set<String> languages) {
        this.osType = osType;
        this.osVersion = osVersion;
        this.osSubVersion = osSubVersion;
        this.device = device;
        this.useragentFamily = useragentFamily;
        this.useragentVerison = useragentVerison;
        this.useragentSubVersion = useragentSubVersion;
        this.accepts = accepts;
        this.encoding = encoding;
        this.languages = languages;
    }

    public String getOsType() {
        return osType;
    }

    public String getOsVersion() {
        return osVersion;
    }

    public String getOsSubVersion() {
        return osSubVersion;
    }

    public String getDevice() {
        return device;
    }

    public String getUseragentFamily() {
        return useragentFamily;
    }

    public String getUseragentVerison() {
        return useragentVerison;
    }

    public String getUseragentSubVersion() {
        return useragentSubVersion;
    }

    public Set<String> getAccepts() {
        return accepts;
    }

    public Set<String> getEncoding() {
        return encoding;
    }

    public Set<String> getLanguages() {
        return languages;
    }

}
