package de.unileipzig.datenschutz.paper10.demo.data;

import jakarta.persistence.*;

@Entity
public class UserSession {

    @Id
    @GeneratedValue(strategy= GenerationType.AUTO)
    private Long id;

    private String sessionID;

    @OneToOne(cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    @JoinColumn(name = "screenSize_id", referencedColumnName = "id")
    private ScreenSizeFinerPrint screenSizeFinerPrint;


    @OneToOne(cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    @JoinColumn(name = "fonts_id", referencedColumnName = "id")
    private FontsFingerprint fontsFingerprint;

    @OneToOne(cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    @JoinColumn(name = "header_id", referencedColumnName = "id")
    private HeaderFingerprint headerFingerprint;

    UserSession(){

    }

    public UserSession(String sessionID){
        this.sessionID = sessionID;
    }

    public String getSessionID() {
        return sessionID;
    }

    public void setSessionID(String sessionID) {
        this.sessionID = sessionID;
    }

    public ScreenSizeFinerPrint getScreenSizeFinerPrint() {
        return screenSizeFinerPrint;
    }

    public void setScreenSizeFinerPrint(ScreenSizeFinerPrint screenSizeFinerPrint) {
        this.screenSizeFinerPrint = screenSizeFinerPrint;
    }

    public FontsFingerprint getFontsFingerprint() {
        return fontsFingerprint;
    }

    public void setFontsFingerprint(FontsFingerprint fontsFingerprint) {
        this.fontsFingerprint = fontsFingerprint;
    }

    public HeaderFingerprint getHeaderFingerprint() {
        return headerFingerprint;
    }

    public void setHeaderFingerprint(HeaderFingerprint headerFingerprint) {
        this.headerFingerprint = headerFingerprint;
    }

}
