package de.unileipzig.datenschutz.paper10.demo.dto;

import de.unileipzig.datenschutz.paper10.demo.data.FontsData;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

public class FontList {

    private List<FontStatus> fonts = new ArrayList<FontStatus>();

    public List<FontStatus> getFonts() {
        return fonts;
    }

    public void setFonts(List<FontStatus> fonts) {
        this.fonts = fonts;
    }

    public FontStatus getFontStatus(int pos){
        return fonts.get(pos);
    }

    public void addFontStatus(FontStatus fontStatus){
        fonts.add(fontStatus);
    }

    public Set<FontsData> getInstalledFonts(){
        return fonts.stream().filter(FontStatus::isActive).map(fontStatus -> new FontsData(fontStatus.getFontName())).collect(Collectors.toSet());
    }

}
