// Form https://gist.github.com/tingletech/1582068

var Detector = function(){
    var h = document.getElementsByTagName("BODY")[0];
    var d = document.createElement("DIV");
    var s = document.createElement("SPAN");
    d.appendChild(s);
    d.style.fontFamily = "serif";    //font for the parent element DIV.
    s.style.fontFamily = "serif";    //have to use serif coz in FF3.0, it doesn't fall back to font of parent element.
    s.style.fontSize   = "72px";      //we test using 72px font size, we may use any size. I guess larger the better.
    s.innerHTML        = "mmmmmmmmmml";    //we use m or w because these two characters take up the maximum width. And we use a L so that the same matching fonts can get separated
    h.appendChild(d);
    var defaultWidth   = s.offsetWidth;    //now we have the defaultWidth
    var defaultHeight  = s.offsetHeight;  //and the defaultHeight, we compare other fonts with these.
    h.removeChild(d);
    /* test
     * params:
     * font - name of the font you wish to detect
     * return:
     * f[0] - Input font name.
     * f[1] - Computed width.
     * f[2] - Computed height.
     * f[3] - Detected? (true/false).
     */
    function debug(font) {
        h.appendChild(d);
        var f = [];
        f[0] = s.style.fontFamily = font;       // Name of the font
        f[1] = s.offsetWidth;                           // Width
        f[2] = s.offsetHeight;                          // Height
        h.removeChild(d);
        font = font.toLowerCase();
        if (font == "serif") {
            f[3] = true;    // to set arial and sans-serif true
        } else {
            f[3] = (f[1] != defaultWidth || f[2] != defaultHeight); // Detected?
        }
        return f;
    }
    function test(font){
        f = debug(font);
        return f[3];
    }
    this.detailedTest = debug;
    this.test = test;
}
var fonts = [];
/**
 * other stuff
 */
function init() {
    fonts.push("cursive");
    fonts.push("Helvetica");
    fonts.push("monospace");
    fonts.push("serif");
    fonts.push("sans-serif");
    fonts.push("fantasy");
    fonts.push("default");
    fonts.push("Arial");
    fonts.push("Arial Black");
    fonts.push("Arial Narrow");
    fonts.push("Arial Rounded MT Bold");
    fonts.push("Bookman Old Style");
    fonts.push("Bradley Hand ITC");
    fonts.push("Century");
    fonts.push("Century Gothic");
    fonts.push("Gotham");
    fonts.push("Comic Sans MS");
    fonts.push("Courier");
    fonts.push("Courier New");
    fonts.push("Georgia");
    fonts.push("Roboto");
    fonts.push("Lato");
    fonts.push("Montserrat");
    fonts.push("Gentium");
    fonts.push("Source Sans Pro");
    fonts.push("Bookman");
    fonts.push("Brush Script");
    fonts.push("PT Sans");
    fonts.push("Raleway");
    fonts.push("Didot");
    fonts.push("Franklin Gothic");
    fonts.push("Open Sans");
    fonts.push("Univers");
    fonts.push("Copperplate");
    fonts.push("Impact");
    fonts.push("Futura");
    fonts.push("Optima");
    fonts.push("Rockwell");
    fonts.push("Gill Sans");
    fonts.push("Zapfino");
    fonts.push("Myriad");
    fonts.push("King");
    fonts.push("Trajan");
    fonts.push("Lucida Console");
    fonts.push("Poppins");
    fonts.push("Lalit");
    fonts.push("Oswald");
    fonts.push("Ubuntu");
    fonts.push("Modena");
    fonts.push("Nunito");
    fonts.push("Monotype Corsiva");
    fonts.push("Papyrus");
    fonts.push("Tahoma");
    fonts.push("Garamond");
    fonts.push("TeX");
    fonts.push("Times");
    fonts.push("Palatino");
    fonts.push("Baskerville");
    fonts.push("Times New Roman");
    fonts.push("Trebuchet MS");
    fonts.push("Verdana");
    fonts.push("Verona");
    d = new Detector();
    // compute height and width for all fonts
    for (i=0; i<fonts.length; i++) {
        fonts.push(d.detailedTest(fonts.shift()));
    }
    sortResults();
}

function sortResults() {
    for (i=0; i<fonts.length-1; i++) {
        for (j=i; j<fonts.length; j++) {
            if(fonts[i][1] < fonts[j][1]) {
                t = fonts[i];
                fonts[i] = fonts[j];
                fonts[j] = t;
            }
        }
    }
}

var fontTracker = function() {

    init();
    console.log(fonts);

    // Sende die erfassten Daten an den Spring REST-Endpunkt
    var xhr = new XMLHttpRequest();
    xhr.open("POST", "/fonts", true);
    xhr.setRequestHeader("Content-Type", "application/json");

    var data = JSON.stringify(fonts);
    console.log(data);

    xhr.send(data);
}

document.addEventListener('DOMContentLoaded', fontTracker, false);